package com.yizhi.message.application.vo;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

/**
 * <p>
 * 消息
 * </p>
 *
 * @author hutao123
 * @since 2019-09-09
 */
@Data
@Api(tags = "MessageVo", description = "消息主体表")
public class MessageVo {

    @ApiModelProperty(value = "id   主体消息表")
    private Long id;

    @ApiModelProperty(value = "消息内容id")
    private Long messageContextId;

    @ApiModelProperty(value = "消息类型：1、自定义消息；2、系统消息；3、事件触发消息 必传")
    private Integer messageType;

    @ApiModelProperty(value = "消息标题")
    private String title;

    @ApiModelProperty(value = "消息内容")
    private String context;

    @ApiModelProperty(value = "伪消息内容")
    private String fakeContext;

    @ApiModelProperty(value = "消息状态")
    private Integer status;

    @ApiModelProperty(value = "模板名称 （系统消息需要）")
    private String templateName;

    @ApiModelProperty(value = "事件名称 （触发消息需要）")
    private String eventName;

    @ApiModelProperty(value = "发送方式：1、站内信；2、短信；3、邮件")
    private Integer sendType;

    @ApiModelProperty(value = "关联模块类型(应用场景)1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分 ")
    private Integer relationType;

    @ApiModelProperty(value = "(应用场景或者活动名称)String   比如：学习计划、考试")
    private String relationTypeString;

    @ApiModelProperty(value = "指定范围(0:全平台,1:指定用户)")
    private Integer visibleRange;

    @ApiModelProperty(value = "发送时间 （新增自定义消息需要）")
    private Date sendTime;

    @ApiModelProperty(value = "可见范围")
    private List<MessageVisibleRangeVo> messageVisibleRange;

    @ApiModelProperty(value = "可变参数id集合")
    private List<Long> messageParameterIds;

    @ApiModelProperty(value = "专门存放提醒时间设置")
    private List<com.yizhi.core.application.vo.MessageTaskRemindVo> messageTaskRemindVos = new ArrayList<>();


}
