package com.yizhi.message.application.controller.util;

import com.yizhi.assignment.application.feign.AssignmentClient;
import com.yizhi.assignment.application.vo.entity.Assignment;
import com.yizhi.core.application.context.RequestContext;
import com.yizhi.exam.application.feign.ExamClient;
import com.yizhi.exam.application.vo.domain.Exam;
import com.yizhi.live.application.feign.LiveActivityClient;
import com.yizhi.live.application.vo.LiveActivityVO;
import com.yizhi.message.application.constans.Constans;
import com.yizhi.message.application.enums.EvenType;
import com.yizhi.message.application.enums.MessageParameterEnums;
import com.yizhi.message.application.enums.ReturnParameterEnums;
import com.yizhi.core.application.vo.TaskVo;
import com.yizhi.message.application.enums.*;
import com.yizhi.research.application.feign.ResearchClient;
import com.yizhi.research.application.vo.domain.ResearchVo;
import com.yizhi.system.application.vo.AccountVO;
import com.yizhi.training.application.feign.TpPlanClient;
import com.yizhi.training.application.feign.TrainingProjectClient;
import com.yizhi.training.application.vo.domain.TpPlanVo;
import com.yizhi.training.application.vo.domain.TrainingProjectVo;
import org.apache.commons.lang.StringUtils;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Map;

@Component
public class MessageUtil {

    private SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
    private Logger logger = LoggerFactory.getLogger(MessageUtil.class);
    @Autowired
    private LiveActivityClient liveActivityClient;
    @Autowired
    private ResearchClient researchClient;
    @Autowired
    private ExamClient examClient;
    @Autowired
    private AssignmentClient assignmentClient;
    @Autowired
    private TrainingProjectClient trainingProjectClient;
    @Autowired
    private TpPlanClient tpPlanClient;


    private MessageUtil() {
    }

    public String getRelationType(Integer key) {
        if (key != null) {
            String relationType = "";
            switch (key) {
                // "关联模块类型(、1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分、11课程)"
                case 0:
                    relationType = RelationType.ZDY.getName();
                    break;
                case 1:
                    relationType = RelationType.XX.getName();
                    break;
                case 2:
                    relationType = RelationType.KS.getName();
                    break;
                case 3:
                    relationType = RelationType.DY.getName();
                    break;
                case 4:
                    relationType = RelationType.TP.getName();
                    break;
                case 5:
                    relationType = RelationType.BM.getName();
                    break;
                case 6:
                    relationType = RelationType.ZY.getName();
                    break;
                case 7:
                    relationType = RelationType.QD.getName();
                    break;
                case 8:
                    relationType = RelationType.XM.getName();
                    break;
                case 9:
                    relationType = RelationType.ZB.getName();
                    break;
                case 10:
                    relationType = RelationType.JF.getName();
                    break;
                case 11:
                    relationType = RelationType.KC.getName();
                    break;
                default:
                    break;
            }
            return relationType;
        }

        return null;
    }

    public String getMessageStatus(Integer key) {
        if (key != null) {
            String messageStatus = "";
            switch (key) {
                //状态   1:草稿、2：待发送、3：发送中、4：已发送、、6：下架、7：上架   （没有发送失败，直接发送中）
                case 0:
                    messageStatus = MessageStatus.DRAFT.getName();
                    break;
                case 1:
                    messageStatus = MessageStatus.DRAFT.getName();
                    break;
                case 2:
                    messageStatus = MessageStatus.TO_SEND.getName();
                    break;
                case 3:
                    messageStatus = MessageStatus.SEND_ING.getName();
                    break;
                case 4:
                    messageStatus = MessageStatus.SEND_ED.getName();
                    break;
                case 6:
                    messageStatus = MessageStatus.DOWN.getName();
                    break;
                case 7:
                    messageStatus = MessageStatus.UP.getName();
                    break;
                case 8:
                    messageStatus = MessageStatus.SEND_ED_CANCEl.getName();
                    break;

                default:
                    break;
            }
            return messageStatus;
        }

        return null;
    }


//    /**
//     * 直接根据可见范围发消息
//     *
//     * @param accountVOS 各个业务可见范围
//     * @param context
//     * @param taskVo     业务参数对象
//     * @return
//     */
//    public Boolean insertAccountMessage(String messageContext, List<AccountVO> accountVOS, RequestContext context, TaskVo taskVo) {
//
//        if (!CollectionUtils.isEmpty(accountVOS)) {
//            List<AccountVO> accountVOList = new ArrayList<>(accountVOS.size());
//            //目前不对消息做唯一性限制
////            if (taskVo.getRelationId() != null && taskVo.getRelationType() != null) {
////                //对于单个用户，判断是否已经收到消息，避免重复发送消息
////                if (accountVOS.size() == 1) {
////                    MessageAccountVo one = remoteMessageAccountClient.getOne(accountVOS.get(0).getId(), taskVo.getRelationType(), taskVo.getRelationId());
////                    if (one != null) {
////                        return false;
////                    }
////                } else {
////                    //对于多个用户，判断是否已经收到消息，避免重复发送消息
////                    List<MessageAccountVo> messageAccounts = remoteMessageAccountClient.getList(taskVo.getRelationType(), taskVo.getRelationId());
////                    if (!CollectionUtils.isEmpty(messageAccounts)) {
////                        Set<Long> accountIds = new HashSet<>(messageAccounts.size());
////                        messageAccounts.forEach(a -> {
////                            accountIds.add(a.getAccountId());
////                        });
////                        accountVOS.forEach(a -> {
////                            if (!accountIds.contains(a.getId())) {
////                                accountVOList.add(a);
////                            }
////                        });
////                    }
////                }
////            }
//
//            List<MessageAccountVo> messageAccounts = new ArrayList<>(accountVOList.size());
//            for (AccountVO vo : accountVOList) {
//                MessageAccountVo messageAccount = new MessageAccountVo();
//                messageAccount.setId(idGenerator.generate());
//                messageAccount.setReaded(Constans.NOT_READ);
//                messageAccount.setAccountId(vo.getId());
//                messageAccount.setRelationType(taskVo.getRelationType());
//                messageAccount.setRelationId(taskVo.getRelationId());
//                messageAccount.setSiteId(context.getSiteId());
//                messageAccount.setCompanyId(context.getCompanyId());
//                messageAccount.setCreateByName(context.getAccountName());
//                messageAccount.setCreateTime(taskVo.getNow());
//                messageAccount.setCreateById(context.getAccountId());
//                messageContext = getCompleteContext(messageContext, vo);
//                messageAccount.setContext(messageContext);
//                messageAccounts.add(messageAccount);
//            }
//            return remoteMessageAccountClient.save(messageAccounts);
//        }
//        return false;
//    }


    /**
     * 把带用户姓名参数的消息解析，成完整消息
     *
     * @param context
     * @param accounId
     * @param map
     * @return
     */
    public String getCompleteContext(String context, Long accounId, Map<Long, AccountVO> map) {

        if (!StringUtils.isBlank(context)) {
            String accountName = "默认";
            if (map != null) {
                AccountVO accountVO = map.get(accounId);
                if (accountVO != null) {
                    accountName = (accountVO.getFullName() == null ? (accountVO.getName() == null ? "默认" : accountVO.getName()) : accountVO.getFullName());
                    //必须赋值给context
                    context = context.replace(MessageParameterEnums.accountName.getName(), accountName);
                }
            }
        }
        return context;
    }

    /**
     * 把带用户姓名参数的消息解析，成完整消息  这个适用于单个用户
     *
     * @param context
     * @param content
     * @return
     */
    public String getCompleteContext(String content,  RequestContext context) {

        if (!StringUtils.isBlank(content)) {
            String accountName = "默认";
            if (context != null) {
                String fullName = context.getAccountFullName();
                String name = context.getAccountName();
                accountName = (fullName == null ? (name == null ? "默认" : name) : (fullName.equals("") ? name : fullName));
                //必须赋值给context
                content = content.replace(MessageParameterEnums.accountName.getName(), accountName);
            } else {
                logger.info("下上文！！！！！！！！！");
            }
        }
        return content;
    }

    /**
     * 组建消息内容 目前此处只解析业务参数  不对用户名称做解析
     *
     * @param fieldType      可选参数类型 详情见MessageParameterEnums
     * @param messageContext 原始消息内容
     * @param taskVo         业务参数对象
     * @return
     */
    public String buildMessageContext(Integer fieldType, String messageContext, TaskVo taskVo) {
        if (fieldType == null || StringUtils.isBlank(messageContext)) {
            return messageContext;
        }
        StringBuffer nameBuffer = new StringBuffer("");
        StringBuffer timeBuffer = new StringBuffer("");
        StringBuffer scoreBuffer = new StringBuffer("");
        StringBuffer reasonBuffer = new StringBuffer("");

        String taskName = taskVo.getTaskName();
        Date taskStartTime = taskVo.getTaskStratTime();
        Date taskEndTime = taskVo.getTaskEndTime();
        Double taskScore = taskVo.getTaskScore();
        String reason = taskVo.getReason();
        if (taskName != null) {
            nameBuffer = new StringBuffer("【").append(taskName).append("】");
        }
        if (taskStartTime != null && taskEndTime != null) {
            timeBuffer = new StringBuffer("【").append(format.format(taskStartTime))
                    .append("--").append(format.format(taskEndTime)).append("】");
        }else {
            if (taskStartTime != null) {
                timeBuffer = new StringBuffer("【").append(format.format(taskStartTime)).append("】");
            }
            if (taskEndTime != null) {
                timeBuffer.append("【").append(format.format(taskEndTime)).append("】");
            }
        }
        if (taskScore != null) {
            scoreBuffer.append("【").append(taskScore).append("】");
        }
        if (reasonBuffer != null) {
            reasonBuffer.append("【").append(reason).append("】");
        }
        switch (fieldType) {
            case 1:
                return messageContext;
            case 2:
                return messageContext.replace(MessageParameterEnums.courseName.getName(), nameBuffer);
            case 3:
                return messageContext.replace(MessageParameterEnums.projectTime.getName(), timeBuffer);
            case 4:
                return messageContext.replace(MessageParameterEnums.projectName.getName(), nameBuffer);
            case 5:
                return messageContext.replace(MessageParameterEnums.enrollEndTime.getName(), timeBuffer);
            case 6:
                return messageContext.replace(MessageParameterEnums.assignmentName.getName(), nameBuffer);
            case 7:
                return messageContext.replace(MessageParameterEnums.assignmentTime.getName(), timeBuffer);
            case 8:
                return messageContext.replace(MessageParameterEnums.assignmentScore.getName(), scoreBuffer);
            case 9:
                return messageContext.replace(MessageParameterEnums.examName.getName(), nameBuffer);
            case 10:
                return messageContext.replace(MessageParameterEnums.examTime.getName(), timeBuffer);
            case 11:
                return messageContext.replace(MessageParameterEnums.examScore.getName(), scoreBuffer);
            case 12:
                return messageContext.replace(MessageParameterEnums.changeReason.getName(), reasonBuffer);
            case 13:
                return messageContext.replace(MessageParameterEnums.changePoint.getName(), scoreBuffer);
            case 14:
                return messageContext.replace(MessageParameterEnums.changeTime.getName(), timeBuffer);
            case 15:
                return messageContext.replace(MessageParameterEnums.researchTime.getName(), timeBuffer);
            case 16:
                return messageContext.replace(MessageParameterEnums.researchName.getName(), nameBuffer);
            case 17:
                return messageContext.replace(MessageParameterEnums.liveTime.getName(), timeBuffer);
        }
        return messageContext;
    }

    /**
     * 统一可见范围类型，由于业务的可见范围类型不统一，这里集中处理
     *
     * @param relationType 业务类型
     * @param scope        可见范围类型
     * @return
     */
    public Integer getVisibleRange(Integer relationType, Integer scope) {
        if (relationType == null || scope == null) {
            logger.info("可见范围条件为空！！！");
            return -1;
        }
        switch (relationType) {
            // "关联模块类型(、1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分、11课程)"
            case 1:
                if (scope == 0) {
                    return Constans.VISIBLE_RANGE;
                } else {
                    return Constans.PUBLIC_SITE;
                }
            case 2:
                if (scope == 2) {
                    return Constans.VISIBLE_RANGE;
                } else {
                    return Constans.PUBLIC_SITE;
                }
            case 3:
                if (scope == 2) {
                    return Constans.VISIBLE_RANGE;
                } else {
                    return Constans.PUBLIC_SITE;
                }
            case 4:
                break;
            case 5:
                if (scope == 0) {
                    return Constans.VISIBLE_RANGE;
                } else {
                    return Constans.PUBLIC_SITE;
                }
            case 6:
                if (scope == 2) {
                    return Constans.VISIBLE_RANGE;
                } else {
                    return Constans.PUBLIC_SITE;
                }
            case 7:
                break;
            case 8:
                if (scope == 0) {
                    return Constans.VISIBLE_RANGE;
                } else {
                    return Constans.PUBLIC_SITE;
                }
            case 9:
                if (scope == 1) {
                    return Constans.VISIBLE_RANGE;
                } else {
                    return Constans.PUBLIC_SITE;
                }
            case 10:
                break;
            case 11:
                if (scope == 1) {
                    return Constans.PUBLIC_SITE;
                } else {
                    return Constans.VISIBLE_RANGE;
                }
        }
        return null;
    }

    /**
     * 用于触发事件消息   根据触发类型 解析业务参数，组装消息内容
     * 根据
     *
     * @param evenType
     * @return
     */
    public String getContextByEvenType(EvenType evenType, String messageContext, TaskVo taskVo) {
        if (!StringUtils.isBlank(messageContext)) {
            List<Integer> fieldTypes = new ArrayList<>(20);
            switch (evenType) {
                case COURSE_UP:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case COURSE_FINISH:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case ENROLL_START:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case TRAINING_AUDIT_PASS:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case TRAINING_AUDIT_FAIL:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case SIGN_SUCCESS:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case TRAINING_FINISH:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case ASSIGNMENT_AUDIT_FINISH:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;

                case EXAM_AUDIT_FINISH:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
                case POINT_CHANGE:
                    fieldTypes = EvenType.COURSE_UP.getName();
                    for (Integer a : fieldTypes) {
                        messageContext = buildMessageContext(a, messageContext, taskVo);
                    }
                    break;
            }
        }
        return messageContext;
    }

    public String returnParameter(Integer relationType, String content) {

        if (relationType != null) {
            content = content.replace(MessageParameterEnums.accountName.getName(), ReturnParameterEnums.accountName.getCode());
            switch (relationType) {
                // "关联模块类型(0自定义消息、1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分、11课程)"
                case 0:
                    break;
                case 1:
                    content = content.replace(MessageParameterEnums.projectName.getName(), ReturnParameterEnums.projectName.getCode());
                    break;
                case 2:
                    content = content.replace(MessageParameterEnums.examTime.getName(), ReturnParameterEnums.examTime.getCode());
                    content = content.replace(MessageParameterEnums.examName.getName(), ReturnParameterEnums.examName.getCode());
                    break;
                case 3:
                    content = content.replace(MessageParameterEnums.researchTime.getName(), ReturnParameterEnums.researchTime.getCode());
                    content = content.replace(MessageParameterEnums.researchName.getName(), ReturnParameterEnums.researchName.getCode());
                    break;
                case 4:
                    break;
                case 5:
                    content = content.replace(MessageParameterEnums.projectTime.getName(), ReturnParameterEnums.projectTime.getCode());
                    content = content.replace(MessageParameterEnums.enrollEndTime.getName(), ReturnParameterEnums.enrollEndTime.getCode());
                    content = content.replace(MessageParameterEnums.projectName.getName(), ReturnParameterEnums.projectName.getCode());
                    break;
                case 6:
                    content = content.replace(MessageParameterEnums.assignmentTime.getName(), ReturnParameterEnums.assignmentTime.getCode());
                    content = content.replace(MessageParameterEnums.assignmentName.getName(), ReturnParameterEnums.assignmentName.getCode());
                    content = content.replace(MessageParameterEnums.assignmentScore.getName(), ReturnParameterEnums.assignmentScore.getCode());
                    break;
                case 7:
                    content = content.replace(MessageParameterEnums.projectTime.getName(), ReturnParameterEnums.projectTime.getCode());
                    content = content.replace(MessageParameterEnums.projectName.getName(), ReturnParameterEnums.projectName.getCode());
                    break;
                case 8:
                    content = content.replace(MessageParameterEnums.projectTime.getName(), ReturnParameterEnums.projectTime.getCode());
                    content = content.replace(MessageParameterEnums.projectName.getName(), ReturnParameterEnums.projectName.getCode());
                    content = content.replace(MessageParameterEnums.enrollEndTime.getName(), ReturnParameterEnums.enrollEndTime.getCode());
                    break;
                case 9:
                    content = content.replace(MessageParameterEnums.liveTime.getName(), ReturnParameterEnums.liveTime.getCode());
                    break;
                case 10:
                    content = content.replace(MessageParameterEnums.changePoint.getName(), ReturnParameterEnums.changePoint.getCode());
                    content = content.replace(MessageParameterEnums.changeReason.getName(), ReturnParameterEnums.changeReason.getCode());
                    content = content.replace(MessageParameterEnums.changeTime.getName(), ReturnParameterEnums.changeTime.getCode());
                    break;
                case 11:
                    content = content.replace(MessageParameterEnums.courseName.getName(), ReturnParameterEnums.courseName.getCode());
                    break;
                default:
                    break;
            }

        } else {
            logger.info("relationType为空！！！");
        }

        return content;
    }

    public Boolean isUp(Long relationId, Integer relationType) {

        if (relationType != null) {

            switch (relationType) {

                // "关联模块类型(0自定义消息、1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分、11课程)"
                case 0:
                    break;
                case 1:
                    TpPlanVo tpPlan = tpPlanClient.getOne(relationId);
                    if (tpPlan != null) {
                        TrainingProjectVo one = trainingProjectClient.getOne(tpPlan.getTrainingProjectId());
                        if (one != null) {
                            if (one.getStatus() == 1) {
                                return true;
                            }
                        }
                    }
                    break;
                case 2:

                    Exam exam = examClient.examViewInfo(relationId);
                    if (exam != null) {
                        if (exam.getState() == 2) {
                            return true;
                        }
                    }
                    break;
                case 3:
                    ResearchVo research = researchClient.viewOne(relationId);
                    if (research != null) {
                        if (research.getState() == 1) {
                            return true;
                        }
                    }
                    break;
                case 4:
                    break;
                case 5:

                    break;
                case 6:

                    Assignment assignment = assignmentClient.get(relationId);
                    if (assignment != null) {
                        if (assignment.getStatus() == 2) {
                            return true;
                        }
                    }
                    break;
                case 7:

                    break;
                case 8:
                    TrainingProjectVo one = trainingProjectClient.getOne(relationId);
                    if (one != null) {
                        if (one.getStatus() == 1) {
                            return true;
                        }
                    }
                    break;
                case 9:
                    LiveActivityVO live = liveActivityClient.getLive(relationId);
                    if (live != null) {
                        if (live.getShelves() == 1) {
                            return true;
                        }
                    }
                    break;
                case 10:

                    break;
                case 11:
                    break;
            }
        }
        return false;
    }
}