package com.yizhi.message.application.domain;

import com.baomidou.mybatisplus.activerecord.Model;
import com.baomidou.mybatisplus.annotations.TableField;
import com.baomidou.mybatisplus.annotations.TableId;
import com.baomidou.mybatisplus.annotations.TableName;
import com.baomidou.mybatisplus.enums.FieldFill;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiModelProperty;
import lombok.Data;

import java.io.Serializable;
import java.util.Date;

/**
 * <p>
 * 消息
 * </p>
 *
 * @author hutao123
 * @since 2019-09-09
 */
@Data
@Api(tags = "MessageVo", description = "消息主体表")
@TableName("message")
public class Message extends Model<Message> {

    private static final long serialVersionUID = 1L;


    @ApiModelProperty(value = "id   主体消息表")
    @TableId("id")
    private Long id;

    @ApiModelProperty(value = "消息类型：1、自定义消息；2、系统消息；3、事件触发消息")
    @TableField("message_type")
    private Integer messageType;

    @ApiModelProperty(value = "消息标题")
    @TableField("title")
    private String title;

    @ApiModelProperty(value = "模板名称 （系统消息需要）")
    @TableField("template_name")
    private String templateName;

    @ApiModelProperty(value = "事件名称 （触发消息需要）")
    @TableField("event_name")
    private String eventName;

    @ApiModelProperty(value = "发送方式：1、站内信；2、短信；3、邮件")
    @TableField("send_type")
    private Integer sendType;

    @ApiModelProperty(value = "关联模块类型(应用场景)1：学习计划、2：考试、3：调研、4、投票5：报名、6：作业、7：签到、8：项目、9：直播、10：积分 ")
    @TableField("relation_type")
    private Integer relationType;

    @ApiModelProperty(value = "状态   1:草稿、2：待发送、3：发送中、4：已发送、、6：下架、7：上架、8：已发送被撤回  （没有发送失败，直接发送中）")
    @TableField("status")
    private Integer status;

    @ApiModelProperty(value = "指定范围(0:全平台,1:指定用户)")
    @TableField("visible_range")
    private Integer visibleRange;

    @ApiModelProperty(value = "是否删除(0:否,1:是)")
    @TableField("deleted")
    private Integer deleted;

    @ApiModelProperty(value = "发送时间 （新增自定义消息需要）")
    @TableField("send_time")
    private Date sendTime;

    @ApiModelProperty(value = "站点id")
    @TableField("site_id")
    private Long siteId;

    @ApiModelProperty(value = "公司id")
    @TableField("company_id")
    private Long companyId;

    @ApiModelProperty(value = "触发消息类型")
    @TableField("even_type")
    private Long evenType;

    @ApiModelProperty(value = "创建人id")
    @TableField(value = "create_by_id", fill = FieldFill.INSERT)
    private Long createById;

    @ApiModelProperty(value = "创建人账号")
    @TableField(value = "create_by_name", fill = FieldFill.INSERT)
    private String createByName;

    @ApiModelProperty(value = "创建时间")
    @TableField(value = "create_time", fill = FieldFill.INSERT)
    private Date createTime;

    @ApiModelProperty(value = "修改人id")
    @TableField(value = "update_by_id", fill = FieldFill.INSERT)
    private Long updateById;

    @ApiModelProperty(value = "修改人账号")
    @TableField(value = "update_by_name", fill = FieldFill.INSERT)
    private String updateByName;

    @ApiModelProperty(value = "修改时间")
    @TableField(value = "update_time", fill = FieldFill.INSERT)
    private Date updateTime;


    @Override
    protected Serializable pkVal() {
        return this.id;
    }

}
